# -*- coding: utf-8 -*-
#
#  Copyright (C) 2001, 2002 by Tamito KAJIYAMA
#  Copyright (C) 2002, 2003 by MATSUMURA Namihiko <nie@counterghost.net>
#  Copyright (C) 2002-2011 by Shyouzou Sugitani <shy@users.sourceforge.jp>
#  Copyright (C) 2003-2005 by Shun-ichi TAHARA <jado@flowernet.gr.jp>
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License (version 2) as
#  published by the Free Software Foundation.  It is distributed in the
#  hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
#  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
#  PURPOSE.  See the GNU General Public License for more details.
#

import socket
import multiprocessing


class BasePlugin(multiprocessing.Process):

    def __init__(self, port, directory, args):
        multiprocessing.Process.__init__(self)
        self.sstp_port = port
        self.directory = directory
        self.args = args

    def send_script(self, sender, script, if_ghost=None):
        if self.sstp_port is None:
            return
        address = ("", self.sstp_port)
        sstp = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        try:
            sstp.connect(address)
        except socket.error:
            raise SystemExit, 'cannot connect to the SSTP server.'
        message = ''.join(('SEND SSTP/1.4\r\n',
                           'Sender: ', sender, '\r\n',
                           'Script: ', script, '\r\n',
                           'Charset: UTF-8\r\n'))
        if if_ghost is not None:
            message = ''.join((message, 'IfGhost: ', if_ghost, '\r\n'))
        message = ''.join((message, '\r\n'))
        sstp.send(message)
        sstp.recv(1024)
        sstp.close()
